(function betterttv() {
    var script = document.createElement('script');
    script.type = 'text/javascript';
    script.src = chrome.extension.getURL('betterttv.js');
    var head = document.getElementsByTagName('head')[0];
    if (!head) return;
    head.appendChild(script);

    const expectedExtensionID = new URL(script.src).host;
    window.addEventListener('message', (event) => {
        if (event.origin !== window.origin) {
            return;
        }

        try {
            const parsedData = JSON.parse(event.data);
            if (parsedData.extensionId !== expectedExtensionID || parsedData.type !== 'BETTERTTV_EXTENSION_COMMAND') {
                return;
            }

            chrome.runtime.sendMessage(parsedData.data, (result) => event.source.postMessage(JSON.stringify({
                extensionId: expectedExtensionID,
                type: 'BETTERTTV_EXTENSION_COMMAND_RESPONSE',
                data: result,
            })));
        } catch (_) {}
    }, false);
})()
